"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const boa = require('@pipcook/boa');
const detectronModelEvaluate = (data, model, args) => __awaiter(void 0, void 0, void 0, function* () {
    let { modelDir } = args;
    const { register_coco_instances } = boa.import('detectron2.data.datasets');
    const { testLoader } = data;
    const cfg = model.config;
    if (testLoader && model.model) {
        const trainer = model.model;
        const { COCOEvaluator, inference_on_dataset } = boa.import('detectron2.evaluation');
        const { build_detection_test_loader } = boa.import('detectron2.data');
        register_coco_instances("test_dataset", {}, data.testAnnotationPath, path.join(data.testAnnotationPath, '..'));
        cfg.DATASETS.TEST = ["test_dataset"];
        const evaluator = COCOEvaluator("test_dataset", cfg, false, boa.kwargs({ output_dir: modelDir }));
        const val_loader = build_detection_test_loader(cfg, "val_dataset");
        const val_result = inference_on_dataset(trainer.model, val_loader, evaluator);
        return {
            result: val_result
        };
    }
});
exports.default = detectronModelEvaluate;
//# sourceMappingURL=index.js.map